xseg                    segment public 'code'
                        assume  cs:xseg, ds:xseg, ss:xseg
                        org     100h

                        public  _gc
                        public  _allocate
                        public  _register_call_table

                        extrn   _space_from : word
                        extrn   _limit_from : word
                        extrn   _space_to : word
                        extrn   _limit_to : word
                        extrn   _next : word

                        extrn   _ret_of_main : near
                        extrn   _puts : proc


MASK_TYPE         = 0C000h
LIST_OF_POINTERS  = 0C000h
LIST_OF_VALUES    = 8000h
ARRAY_OF_POINTERS = 4000h
ARRAY_OF_VALUES   = 0000h
SIZE_MASK         = 3FFFh
FORWARDED         = 0CBADh


;;; -------------------------------------------------------------------
;;; word *forward (word *p)
;;; -------------------------------------------------------------------
;;;   parameter p is in [bp+4]
;;;   result is left in ax
;;;   preserves bp, si, di

_forward                proc    near
                        push    bp
                        mov     bp, sp
                        push    si
                        push    di
                        mov     si, word ptr [bp+4]
        ;; if p points to from_space
                        mov     ax, word ptr _space_from
                        cmp     ax, si
                        ja      @2
                        cmp     si, word ptr _limit_from
                        jae     @2
        ;; if p[0] == FORWARDED
                        cmp     word ptr [si], FORWARDED
                        je      @10
        ;; for i = 0 to SIZE_IN_WORDS(p[0])
                        xor     di, di
                        jmp     short @8
@7:
        ;; next[i] = p[i]
                        mov     bx, di
                        shl     bx, 1
                        mov     ax, word ptr [bx+si]
                        mov     bx, di
                        shl     bx, 1
                        add     bx, word ptr _next
                        mov     word ptr [bx], ax
                        inc     di
@8:
                        mov     ax, word ptr [si]
                        and     ax, SIZE_MASK
                        cmp     ax, di
                        jae     @7
        ;; p[1] = next
                        mov     ax, word ptr _next
                        mov     word ptr [si+2], ax
        ;; next += SIZE_IN_WORDS(p[0]) + 1
                        mov     ax, word ptr [si]
                        and     ax, SIZE_MASK
                        inc     ax
                        shl     ax, 1
                        add     word ptr _next, ax
        ;; p[0] = FORWARDED
                        mov     word ptr [si], FORWARDED
@10:
        ;; return p[1]
                        mov     ax, word ptr [si+2]
                        jmp     short @1
@2:
        ;; return p
                        mov     ax, si
@1:
        ;; end of function
                        pop     di
                        pop     si
                        pop     bp
                        ret
_forward                endp


;;; -------------------------------------------------------------------
;;; void gc ()
;;;    preserves bp
;;; -------------------------------------------------------------------

_gc                     proc    near

                        push    bp
                        mov     bp, sp
                        sub     sp, 6
        ;; scan = next = space_to
                        mov     ax, word ptr _space_to
                        mov     word ptr _next, ax
                        mov     word ptr [bp-6], ax
        ;; base = bp + 2
                        mov     ax, bp
                        add     ax, 2
                        mov     word ptr [bp-2], ax
                        jmp     short @12
@14:
        ;; l = frame_info_table
                        mov     di, word ptr _frame_info_table
                        jmp     short @15
@17:
        ;; l = l[1] (effective from next loop)
                        mov     di, word ptr [di+2]
        ;; if l == 0
                        or      di, di
                        jne     @15
        ;; internal_error()
                        call    near ptr _internal_error
@15:
        ;; while l[0] != base[0]
                        mov     bx, word ptr [bp-2]
                        mov     ax, word ptr [bx]
                        cmp     ax, word ptr [di]
                        jne     @17
        ;; base += l[2]
                        mov     ax, word ptr [di+4]
                        add     word ptr [bp-2], ax
        ;; for i = 3 to ... while l[i] != 0
                        mov     si, 3
                        jmp     short @22
@21:
        ;; base[l[i]] = forward(base[l[i]])
                        mov     bx, si
                        shl     bx, 1
                        mov     bx, word ptr [bx+di]
                        add     bx, word ptr [bp-2]
                        push    word ptr [bx-2] ; offset from ret-addr, not bp!
                        call    near ptr _forward
                        inc     sp
                        inc     sp
                        mov     bx, si
                        shl     bx, 1
                        mov     bx, word ptr [bx+di]
                        add     bx, word ptr [bp-2]
                        mov     word ptr [bx-2], ax
                        inc     si
@22:
                        mov     bx, si
                        shl     bx, 1
                        cmp     word ptr [bx+di], 0
                        jne     @21
@12:
        ;; while base[0] != ret_of_main
                        mov     bx, word ptr [bp-2]
                        mov     ax, word ptr [bx]
                        cmp     ax, OFFSET _ret_of_main
                        jne     @14
                        jmp     @23
@25:
        ;; switch scan[0] & MASK_TYPE
                        mov     bx, word ptr [bp-6]
                        mov     ax, word ptr [bx]
                        and     ax, MASK_TYPE
                        or      ax, ax
                        jne     @37
                        jmp     @34
@37:
                        jg      @36
                        cmp     ax, LIST_OF_VALUES
                        je      @28
                        cmp     ax, LIST_OF_POINTERS
                        je      @27
                        jmp     short @23
@36:
                        cmp     ax, ARRAY_OF_POINTERS
                        je      @29
                        jmp     short @23
@27:
        ;; case LIST_OF_POINTERS:
        ;; scan[1] = forward(scan[1])
                        mov     bx, word ptr [bp-6]
                        push    word ptr [bx+2]
                        call    near ptr _forward
                        inc     sp
                        inc     sp
                        mov     bx, word ptr [bp-6]
                        mov     word ptr [bx+2], ax
@28:
        ;; case LIST_OF_VALUES:
        ;; scan[2] = forward(scan[2])
                        mov     bx, word ptr [bp-6]
                        push    word ptr [bx+4]
                        call    near ptr _forward
                        inc     sp
                        inc     sp
                        mov     bx, word ptr [bp-6]
                        mov     word ptr [bx+4], ax
        ;; scan += 2 + 1
                        add     word ptr [bp-6], 6
        ;; break
                        jmp     short @23
@29:
        ;; case ARRAY_OF_POINTERS:
        ;; for i = 1 to SIZE_IN_WORDS(scan[0])
                        mov     si, 1
                        jmp     short @33
@32:
        ;; scan[i] = forward(scan[i])
                        mov     bx, si
                        shl     bx, 1
                        add     bx, word ptr [bp-6]
                        push    word ptr [bx]
                        call    near ptr _forward
                        inc     sp
                        inc     sp
                        mov     bx, si
                        shl     bx, 1
                        add     bx, word ptr [bp-6]
                        mov     word ptr [bx], ax
                        inc     si
@33:
                        mov     bx, word ptr [bp-6]
                        mov     ax, word ptr [bx]
                        and     ax, SIZE_MASK
                        cmp     ax, si
                        jae     @32
        ;; case ARRAY_OF_VALUES:
        ;; scan += SIZE_IN_WORDS(scan[0]) + 1
@34:
                        mov     bx, word ptr [bp-6]
                        mov     ax, word ptr [bx]
                        and     ax, SIZE_MASK
                        inc     ax
                        shl     ax, 1
                        add     word ptr [bp-6], ax
@23:
        ;; while scan < next
                        mov     ax, word ptr [bp-6]
                        cmp     ax, word ptr _next
                        jae     @38
                        jmp     @25
@38:
        ;; temp = space_from; space_from = space_to; space_to = temp
                        mov     ax, word ptr _space_from
                        mov     word ptr [bp-4], ax
                        mov     ax, word ptr _space_to
                        mov     word ptr _space_from, ax
                        mov     ax, word ptr [bp-4]
                        mov     word ptr _space_to, ax
        ;; temp = limit_from; limit_from = limit_to; limit_to = temp
                        mov     ax, word ptr _limit_from
                        mov     word ptr [bp-4], ax
                        mov     ax, word ptr _limit_to
                        mov     word ptr _limit_from, ax
                        mov     ax, word ptr [bp-4]
                        mov     word ptr _limit_to, ax
        ;; end of function
                        mov	sp, bp
                        pop	bp
                        ret
_gc	                endp


;;; -------------------------------------------------------------------
;;; word * allocate (word code)
;;; -------------------------------------------------------------------
;;;   parameter code is in [bp+8]
;;;   address of result is in [bp+6]
;;;   preserves bp

_allocate       	proc	near
                        push	bp
                        mov     bp, sp
                        sub     sp, 2   ; size (place to spill when GCing)
        ;; size = SIZE_IN_WORDS(code)
                        mov	ax, word ptr [bp+8]
                        and	ax, SIZE_MASK
                        mov     si, ax
        ;; if next + size + 1 >= limit_from
                        inc	ax
                        shl	ax, 1
                        add	ax, word ptr _next
                        cmp	ax, word ptr _limit_from
                        jb	@6
        ;; gc()
                        mov     word ptr [bp-2], si
                        call	near ptr _gc
@allocate_call_1:
        ;; if next + size + 1 >= limit_from
                        mov     si, word ptr [bp-2]
                        mov	ax, si
                        inc	ax
                        shl	ax, 1
                        add	ax, word ptr _next
                        cmp	ax, word ptr _limit_from
                        jb	@6
        ;; out_of_memory()
                        call	near ptr _out_of_memory
@6:
        ;; result = next
                        mov	di, word ptr _next
        ;; result[0] = code
                        mov	ax, word ptr [bp+8]
                        mov	word ptr [di], ax
        ;; next += size + 1
                        mov	ax, si
                        inc	ax
                        shl	ax, 1
                        add	word ptr _next, ax
        ;; return result
                        mov	bx, word ptr [bp+6]
                        mov	word ptr [bx], di
        ;; end of function
                        mov     sp, bp
                        pop	bp
                        ret
_allocate               endp

_allocate_call_table:
                        dw      @allocate_call_1
                        dw      0
                        dw      0 + 0 + 2 + 4
                        dw      0


;;; -------------------------------------------------------------------
;;; void out_of_memory ()
;;;   never returns
;;; -------------------------------------------------------------------

_out_of_memory          proc    near
                        lea     si, byte ptr str_out_of_mem
                        push    si
                        sub     sp, 4
                        call    near ptr _puts
                        add     sp, 6
                        mov     ax, 4C00h
                        int     21h
_out_of_memory          endp

str_out_of_mem          db      'Out of memory!', 10, 0


;;; -------------------------------------------------------------------
;;; void internal_error ()
;;;   never returns
;;; -------------------------------------------------------------------

_internal_error         proc    near
                        lea     si, byte ptr str_internal
                        push    si
                        sub     sp, 4
                        call    near ptr _puts
                        add     sp, 6
                        mov     ax, 4C00h
                        int     21h
_internal_error         endp

str_internal            db      'Internal error! (wrong GC info)', 10, 0


;;; -------------------------------------------------------------------
;;; void register (void * table)
;;; registers a function's call table for the GC
;;;   parameter table is in ax
;;;   preserves everything but dx, si
;;; -------------------------------------------------------------------

_register_call_table    proc    near
                        mov     si, ax
@register_loop:        
                        mov     dx, word ptr [si+2]
                        or      dx, dx
                        jz      @register_end
                        mov     si, dx
                        jmp     short @register_loop
@register_end:
                        mov     dx, word ptr _frame_info_table
                        mov     word ptr [si+2], dx
                        mov     word ptr _frame_info_table, ax
                        ret
_register_call_table    endp

_frame_info_table       dw      _allocate_call_table

xseg                    ends
	                end
